using UnityEngine;
using System.Collections;

public class AudioTest : MonoBehaviour {
	public void Start () {
	
	}

    public float[] frequencies = new float[1];
    public float[] offsets = new float[1];

    public void Update()
    {
        if (frequencies.Length != offsets.Length) {
            offsets = new float[frequencies.Length];
        }
	}

    public void OnEnable()
    {

        AudioSource src;
        if (GetComponent<AudioSource>())
            src = GetComponent<AudioSource>();
        else
            src = gameObject.AddComponent<AudioSource>();
        src.Play();
    }


    public void OnAudioFilterRead(float[] data, int channels) {
        for (var i = 0; i < data.Length; ++i)
        {
            data[i] = 0;
        }

        for (var j = 0; j < frequencies.Length; j++)
        {

            for (var i = 0; i < data.Length; i+=1)
            {
                data[i] += Mathf.Sin(offsets[j] + (Mathf.PI * 2 * frequencies[j] * (i) ) / 44100);
            }
            offsets[j] += (Mathf.PI * 2 * frequencies[j] * (data.Length)) / 44100;
            //const float d = 6.28f*10;
            //if (offsets[j] > d) offsets[j] -= d;    
        }

    }
}
