using UnityEngine;
using System.Runtime.InteropServices;

public class CameraMovement : MonoBehaviour
{
#if UNITY_STANDALONE_WIN || UNITY_EDITOR
	[DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
    public static extern int SetCursorPos(int x, int y);
	[DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
    public static extern int GetCursorPos(out int x, out int y);
	private readonly int[] oldPos = new int[2];
#endif
	public float cameraRotateSpeed = 100.0f;
	public float cameraMoveSpeed = 100.0f;
	
	public static Vector3 oldMousePosition = Vector3.zero;
	// Use this for initialization
    public void Start()
	{
		
	}
    public void OnPostRender()
    {
		
	}
	// Update is called once per frame
    public void Update()
	{
		if(cameraMoveSpeed<10)
			cameraMoveSpeed = Mathf.Lerp(cameraMoveSpeed,10,0.01f);
		if(Input.GetButton("Fire2")){
			if(!Screen.lockCursor){
#if UNITY_STANDALONE_WIN || UNITY_EDITOR
				GetCursorPos(out oldPos[0],out oldPos[1]);
#endif
				oldMousePosition = Input.mousePosition;
				Screen.lockCursor = true;
			}
			Vector3 rotation = new Vector3(-Input.GetAxis("Mouse Y"),Input.GetAxis("Mouse X"),Input.GetKey(KeyCode.E)?-0.5f:Input.GetKey(KeyCode.Q)?0.5f:0);
			rotation*=Time.deltaTime*cameraRotateSpeed;
			Vector3 movement = Input.GetAxis("Vertical")*transform.forward + Input.GetAxis("Horizontal")*transform.right;
			movement *= Time.deltaTime*cameraMoveSpeed;
			if(Input.GetKey(KeyCode.LeftShift)){
				movement *= 2;
				rotation *= 2;
			}
			transform.position += movement;
			transform.rotation *= Quaternion.Euler(rotation);
		}
		else{
			if(Screen.lockCursor){
				Screen.lockCursor = false;
#if UNITY_STANDALONE_WIN || UNITY_EDITOR
				SetCursorPos(oldPos[0],oldPos[1]);
#endif
			}
		}
		if(Input.GetKeyDown(KeyCode.Space)){
			GameObject newCube = Instantiate(Resources.Load("SpawnableCube")) as GameObject;
			newCube.renderer.material.color = new Color(0.5f+Random.Range(0.0f,0.5f),0.5f+Random.Range(0.0f,0.5f),0.5f+Random.Range(0.0f,0.5f),1.0f);
			newCube.transform.position = transform.position;
			newCube.transform.rotation = transform.rotation;
			newCube.rigidbody.velocity = transform.forward*20f;
		}
	}
}

