Shader "Clippy" {
	Properties {
		_Color ("Main Color", Color) = (1,1,1,1)
		_planePos ("Clipping Plane Position", Vector) = (0,0,0,1)
		_planeNorm ("Clipping Plane Normal", Vector) = (0,0,0,1)
		_MainTex ("Base (RGB)", 2D) = "white" {}
	}
	SubShader {
		Tags { "RenderType"="Opaque" }
		LOD 200
		
		CGPROGRAM
		#pragma surface surf Lambert

		sampler2D _MainTex;
		fixed4 _Color;
		
		float4 _planePos;
		float4 _planeNorm;
		struct Input {
			float2 uv_MainTex;
			float3 worldPos;
		};
		
		float getDistance(float3 pp, float3 v, float3 p)
		{
			float3 w = (pp-p);
			float res = (v.x * w.x + v.y * w.y + v.z * w.z) / sqrt(v.x*v.x+v.y*v.y+v.z*v.z);
			return res;
		}
		
		void surf (Input IN, inout SurfaceOutput o) {
			clip (getDistance(_planePos.xyz,_planeNorm.xyz,IN.worldPos.xyz));//frac((IN.worldPos.y+IN.worldPos.z*0.1) * 5) - 0.5);
          
			fixed4 c = tex2D(_MainTex, IN.uv_MainTex) * _Color;
			o.Albedo = c.rgb;
			o.Alpha = c.a;
		}
		ENDCG 
	} 
	FallBack "Diffuse"
}
